%Var_Geometry file
%
%
%
% ATTENTION!!!!!!! AT LEAST 2 ELEMENTS FOR EVERY LIFTING SURFACE ARE REQUIRED!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

global plott alpha0 beta0 Vinf rho

% ===========================================
% Aerodynamic Surfaces
% ===========================================

% _____________________________________
% WING DATA
% _____________________________________

SYM_wing		= 1;		% do i have to create also the left wing?

airfoil_wing		= 'NACA4415';
Nc_wing			= 8;		% Number of panels chordwise

xA_wing 		= 0;
yA_wing			= 0;
zA_wing			= 0;

Nbvect_wing 		= 		[2,	2,	2	];		% Number of panels spanwise
crootvect_wing		= 		[1,	1,	0.73	];		% root chord length
ctipvect_wing		= 		[1,	0.73,	0.6	];		% tip chord length
bvect_wing		= 		[2,	2,	1	];		% length
lambdavect_wing 	= pi/180 * 	[0,	5,	5	];		% sweep
deltavect_wing 		= pi/180 * 	[-20,	5,	5	];		% dihedral
eps0vect_wing 		= pi/180 * 	[0,	0,	0	];		% tilt angle at root
epsvect_wing 		= pi/180 * 	[0,	0,	0	];		% airfoil twisting 
FCRvect_wing	 	= 		[0.3,	0,	0.3	];		% FlapChordRatio: 0 -> no flap; 1 -> all moving
xivect_wing		= pi/180 *	[30,	0,	20	];		% flap deflection. any number is ok if FCR = 0
invert_wing		= 		[0,	0,	1	];		% invert deflection on SYM side? flap -> 0 (NO!!!); aileron -> 1 (YESSS)

% _____________________________________
% HORIZONTAL TAIL DATA
% _____________________________________
SYM_htail		= 1;		% do i have to create also the left wing?

airfoil_htail		= 'NACA0012';
Nc_htail		= 8;		% Number of panels chordwise

xA_htail 		= 3.9;
yA_htail		= 0;
zA_htail		= 0.3;

Nbvect_htail 		= 		[2	];		% Number of panels spanwise
crootvect_htail		= 		[0.7	];		% root chord length
ctipvect_htail		= 		[0.5	];		% tip chord length
bvect_htail		= 		[1.3	];		% length
lambdavect_htail 	= pi/180 * 	[10	];		% sweep
deltavect_htail 	= pi/180 * 	[5	];		% dihedral
eps0vect_htail 		= pi/180 * 	[0,	];		% tilt angle at root
epsvect_htail 		= pi/180 * 	[0,	];		% airfoil twisting 
FCRvect_htail	 	= 		[0.4	];		% FlapChordRatio: 0 -> no flap; 1 -> all moving
xivect_htail		= pi/180 *	[10	];		% flap deflection. any number is ok if FCR = 0
invert_htail		= 		[0	];		% invert deflection on SYM side? flap -> 0 (NO!!!); aileron -> 1 (YESSS)


% _____________________________________
% VERTICAL TAIL DATA
% _____________________________________

SYM_vtail		= 0;		% do i have to create also the left wing?

airfoil_vtail		= 'NACA0012';
Nc_vtail		= 8;		% Number of panels chordwise

xA_vtail 		= 3;
yA_vtail		= 0;
zA_vtail		= 0.3;

Nbvect_vtail 		= 		[2,	2 	];		% Number of panels spanwise
crootvect_vtail		= 		[1.6,	0.9	];		% root chord length
ctipvect_vtail		= 		[0.9,	0.5	];		% tip chord length
bvect_vtail		= 		[0.1,	1	];		% length
lambdavect_vtail 	= pi/180 * 	[80,	20	];		% sweep
deltavect_vtail 	= pi/180 * 	[0,	0	];		% dihedral
eps0vect_vtail 		= pi/180 * 	[0,	0	];		% tilt angle at root
epsvect_vtail 		= pi/180 * 	[0,	0	];		% airfoil twisting 
FCRvect_vtail	 	= 		[0,	0.3	];		% FlapChordRatio: 0 -> no flap; 1 -> all moving
xivect_vtail		= pi/180 *	[0,	0	];		% flap deflection. any number is ok if FCR = 0
invert_vtail		= 		[0,	0	];		% invert deflection on SYM side? flap -> 0 (NO!!!); aileron -> 1 (YESSS)



% _____________________________________
% OTHER LIFTING SURFACES DATA
% _____________________________________


