% This script creates the Geometry starting from a loaded Geometry..

global plott alpha0 beta0 Vinf rho

Geometry
Various_Properties

% ===================================================================================
% 			WING
% ===================================================================================


% Starting point of every wing section
DELTAxAvect_wing = bvect_wing.*tan(lambdavect_wing)+ctipvect_wing/2.*(1-cos(epsvect_wing));
DELTAyAvect_wing = bvect_wing;
DELTAzAvect_wing = bvect_wing.*tan(deltavect_wing)+ctipvect_wing/2.*sin(epsvect_wing);


xAvect_wing = [0, cumsum(DELTAxAvect_wing(1:end-1))];
yAvect_wing = [0, cumsum(DELTAyAvect_wing(1:end-1))];
zAvect_wing = [0, cumsum(DELTAzAvect_wing(1:end-1))];

rAvect_wing = [xAvect_wing + xA_wing; yAvect_wing + yA_wing; zAvect_wing + zA_wing];

% Initializing main matrices
	xshapewing = {};	% used only for plotting the shape
	yshapewing = {};
	zshapewing = {};

	surfvectwing = [];	% used to calculate Cp

	xcvwing = [];		% x controlpoint vector
	ycvwing = [];
	zcvwing = [];
	
	xvmatwing = [];		% vortex matrix: columns contain
	yvmatwing = [];		% coordinates of the 4 corners of 
	zvmatwing = [];		% the vortex ring
	
	xnvwing = [];		% n dot x vector
	ynvwing = [];		% n dot y
	znvwing = [];		% n dot z
	
	xmatplotwing = [];
	ymatplotwing = [];
	zmatplotwing = [];

	xyzldedge_wing = [];	% used to calculate mean aerodynamic chord etc..
	xyztredge_wing = [];


for jj = 1:numel(Nbvect_wing)

	r_wing = [rAvect_wing(1,jj),rAvect_wing(2,jj),rAvect_wing(3,jj)];
	

	croot   = crootvect_wing(jj);
	ctip    = ctipvect_wing(jj);
	b	= bvect_wing(jj);
	lambda  = lambdavect_wing(jj);
	delta   = deltavect_wing(jj);
	epsilon0= eps0vect_wing(jj);
	epsilon = epsvect_wing(jj);
	Nc      = Nc_wing;
	Nb      = Nbvect_wing(jj);
	FCR     = FCRvect_wing(jj);
	xi 	= xivect_wing(jj);

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,xyz_ldedge,xyz_tredge] = wing_geometry_function004(airfoil_wing,r_wing,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_wing);

	% SAVING DATA TO GOLBAL MATRICES
	xcvwing = [xcvwing, xc(1:end)];
	ycvwing = [ycvwing, yc(1:end)];
	zcvwing = [zcvwing, zc(1:end)];
	
	xvmatwing = [xvmatwing, xvortic];
	yvmatwing = [yvmatwing, yvortic];
	zvmatwing = [zvmatwing, zvortic];
	
	xnvwing = [xnvwing; nx];
	ynvwing = [ynvwing; ny];
	znvwing = [znvwing; nz];
	
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapewing{jj} = xshape;
	yshapewing{jj} = yshape;
	zshapewing{jj} = zshape;

	surfvectwing = [surfvectwing; surfv];

	xyzldedge_wing = [xyzldedge_wing, xyz_ldedge];
	xyztredge_wing = [xyztredge_wing, xyz_tredge];
%	xmat_chord_wing = [xmat_chord_wing, xvmat_wing];
%	ymat_chord_wing = [ymat_chord_wing, yvmat_wing];
%	zmat_chord_wing = [zmat_chord_wing, zvmat_wing];


if SYM_wing == 1		% ############################## SYMMETRY #############################

	r_wing = [rAvect_wing(1,jj),-rAvect_wing(2,jj),rAvect_wing(3,jj)];
	

	croot   = crootvect_wing(jj);
	ctip    = ctipvect_wing(jj);
	b	= -bvect_wing(jj);
	lambda  = -lambdavect_wing(jj);
	delta   = -deltavect_wing(jj);
	epsilon0= eps0vect_wing(jj);
	epsilon = epsvect_wing(jj);
	Nc      = Nc_wing;
	Nb      = Nbvect_wing(jj);
	FCR     = FCRvect_wing(jj);
	xi 	= xivect_wing(jj);
	if invert_wing(jj) == 1; xi = -xi; end	

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,dummy,dummy] = wing_geometry_function004(airfoil_wing,r_wing,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_wing);


	% SAVING DATA TO GOLBAL MATRICES
	xcvwing = [xcvwing, xc(1:end)];
	ycvwing = [ycvwing, yc(1:end)];
	zcvwing = [zcvwing, zc(1:end)];
	

	xvortic = xvortic(end:-1:1,:);	% CUIDADO!!! Vortex are reversed in simmetric condition!
	yvortic = yvortic(end:-1:1,:);	% if we don't reverse them, we obtain half a wing lifting 
	zvortic = zvortic(end:-1:1,:);	% and the other half ANTI LIFTING!
	
	xvmatwing = [xvmatwing, xvortic];
	yvmatwing = [yvmatwing, yvortic];
	zvmatwing = [zvmatwing, zvortic];
	
	xnvwing = [xnvwing; -nx];
	ynvwing = [ynvwing; -ny];
	znvwing = [znvwing; -nz];
	
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapewing{numel(Nbvect_wing) + jj} = xshape;
	yshapewing{numel(Nbvect_wing) + jj} = yshape;
	zshapewing{numel(Nbvect_wing) + jj} = zshape;

	surfvectwing = [surfvectwing; surfv];
end % ...if SYM == 1...
end




% ===================================================================================
% 			HORIZONTAL TAIL 
% ===================================================================================

% Starting point of every tail section
DELTAxAvect_htail = bvect_htail.*sin(lambdavect_htail)+ctipvect_htail/2.*(1-cos(epsvect_htail));
DELTAyAvect_htail = bvect_htail;
DELTAzAvect_htail = bvect_htail.*sin(deltavect_htail)+ctipvect_htail/2.*sin(epsvect_htail);


xAvect_htail = [0, cumsum(DELTAxAvect_htail(1:end-1))];
yAvect_htail = [0, cumsum(DELTAyAvect_htail(1:end-1))];
zAvect_htail = [0, cumsum(DELTAzAvect_htail(1:end-1))];

rAvect_htail = [xAvect_htail + xA_htail; yAvect_htail + yA_htail; zAvect_htail + zA_htail];

% Initializing main matrices
	xshapehtail = {};	% used only for plotting the shape
	yshapehtail = {};
	zshapehtail = {};

	surfvecthtail = [];	% used to calculate Cp

	xcvhtail = [];		% x controlpoint vector
	ycvhtail = [];
	zcvhtail = [];
	
	xvmathtail = [];		% vortex matrix: columns contain
	yvmathtail = [];		% coordinates of the 4 corners of 
	zvmathtail = [];		% the vortex ring
	
	xnvhtail = [];		% n dot x vector
	ynvhtail = [];		% n dot y
	znvhtail = [];		% n dot z
	
	xmatplothtail = [];
	ymatplothtail = [];
	zmatplothtail = [];

	xyzldedge_htail = [];	% used to calculate mean aerodynamic chord etc..
	xyztredge_htail = [];

for jj = 1:numel(Nbvect_htail)

	r_htail = [rAvect_htail(1,jj),rAvect_htail(2,jj),rAvect_htail(3,jj)];
	

	croot   = crootvect_htail(jj);
	ctip    = ctipvect_htail(jj);
	b	= bvect_htail(jj);
	lambda  = lambdavect_htail(jj);
	delta   = deltavect_htail(jj);
	epsilon0= eps0vect_htail(jj);
	epsilon = epsvect_htail(jj);
	Nc      = Nc_htail;
	Nb      = Nbvect_htail(jj);
	FCR     = FCRvect_htail(jj);
	xi 	= xivect_htail(jj);

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,xyz_ldedge,xyz_tredge] = wing_geometry_function004(airfoil_htail,r_htail,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_htail);


	% SAVING DATA TO GOLBAL MATRICES
	xcvhtail = [xcvhtail, xc(1:end)];
	ycvhtail = [ycvhtail, yc(1:end)];
	zcvhtail = [zcvhtail, zc(1:end)];
	
	xvmathtail = [xvmathtail, xvortic];
	yvmathtail = [yvmathtail, yvortic];
	zvmathtail = [zvmathtail, zvortic];
	
	xnvhtail = [xnvhtail; nx];
	ynvhtail = [ynvhtail; ny];
	znvhtail = [znvhtail; nz];
	
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapehtail{jj} = xshape;
	yshapehtail{jj} = yshape;
	zshapehtail{jj} = zshape;

	surfvecthtail = [surfvecthtail; surfv];

	xyzldedge_htail = [xyzldedge_htail, xyz_ldedge];
	xyztredge_htail = [xyztredge_htail, xyz_tredge];


if SYM_htail == 1		% ############################## SYMMETRY #############################

	r_htail = [rAvect_htail(1,jj),-rAvect_htail(2,jj),rAvect_htail(3,jj)];
	

	croot   = crootvect_htail(jj);
	ctip    = ctipvect_htail(jj);
	b	= -bvect_htail(jj);
	lambda  = -lambdavect_htail(jj);
	delta   = -deltavect_htail(jj);
	epsilon0= eps0vect_htail(jj);	
	epsilon = epsvect_htail(jj);
	Nc      = Nc_htail;
	Nb      = Nbvect_htail(jj);
	FCR     = FCRvect_htail(jj);
	xi 	= xivect_htail(jj);
	if invert_htail(jj) == 1; xi = -xi; end	

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,dummy,dummy] = wing_geometry_function004(airfoil_htail,r_htail,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_htail);


	% SAVING DATA TO GOLBAL MATRICES
	xcvhtail = [xcvhtail, xc(1:end)];
	ycvhtail = [ycvhtail, yc(1:end)];
	zcvhtail = [zcvhtail, zc(1:end)];
	

	xvortic = xvortic(end:-1:1,:);	% CUIDADO!!! Vortex are reversed in simmetric condition!
	yvortic = yvortic(end:-1:1,:);	% if we don't reverse them, we obtain half a wing lifting 
	zvortic = zvortic(end:-1:1,:);	% and the other half ANTI LIFTING!

	xvmathtail = [xvmathtail, xvortic];
	yvmathtail = [yvmathtail, yvortic];
	zvmathtail = [zvmathtail, zvortic];
	
	xnvhtail = [xnvhtail; -nx];
	ynvhtail = [ynvhtail; -ny];
	znvhtail = [znvhtail; -nz];
	
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapehtail{numel(Nbvect_htail) + jj} = xshape;
	yshapehtail{numel(Nbvect_htail) + jj} = yshape;
	zshapehtail{numel(Nbvect_htail) + jj} = zshape;

	surfvecthtail = [surfvecthtail; surfv];

end % if SYM == 1
end










% ===================================================================================
% 			VERTICAL TAIL 
% ===================================================================================

% Starting point of every tail section
DELTAxAvect_vtail = bvect_vtail.*tan(lambdavect_vtail)+ctipvect_vtail/2.*(1-cos(epsvect_vtail));
DELTAyAvect_vtail = bvect_vtail.*sin(deltavect_vtail)+ctipvect_vtail/2.*sin(epsvect_vtail);
DELTAzAvect_vtail = bvect_vtail;
%DELTAzAvect_vtail = bvect_vtail.*cos(lambdavect_vtail);


xAvect_vtail = [0, cumsum(DELTAxAvect_vtail(1:end-1))];
yAvect_vtail = [0, cumsum(DELTAyAvect_vtail(1:end-1))];
zAvect_vtail = [0, cumsum(DELTAzAvect_vtail(1:end-1))];

rAvect_vtail = [xAvect_vtail + xA_vtail; yAvect_vtail + yA_vtail; zAvect_vtail + zA_vtail];

% Initializing main matrices
	xshapevtail = {};	% used only for plotting the shape
	yshapevtail = {};
	zshapevtail = {};

	surfvectvtail = [];	% used to calculate Cp

	xcvvtail = [];		% x controlpoint vector
	ycvvtail = [];
	zcvvtail = [];
	
	xvmatvtail = [];		% vortex matrix: columns contain
	yvmatvtail = [];		% coordinates of the 4 corners of 
	zvmatvtail = [];		% the vortex ring
	
	xnvvtail = [];		% n dot x vector
	ynvvtail = [];		% n dot y
	znvvtail = [];		% n dot z
	
	xmatplotvtail = [];
	ymatplotvtail = [];
	zmatplotvtail = [];

	xyzldedge_vtail = [];
	xyztredge_vtail = [];


for jj = 1:numel(Nbvect_vtail)

	r_vtail = [rAvect_vtail(1,jj),rAvect_vtail(2,jj),rAvect_vtail(3,jj)];
	

	croot   = crootvect_vtail(jj);
	ctip    = ctipvect_vtail(jj);
	b	= bvect_vtail(jj);
	lambda  = lambdavect_vtail(jj);
	delta   = deltavect_vtail(jj);
	epsilon0= eps0vect_vtail(jj);
	epsilon = epsvect_vtail(jj);
	Nc      = Nc_vtail;
	Nb      = Nbvect_vtail(jj);
	FCR     = FCRvect_vtail(jj);
	xi 	= xivect_vtail(jj);

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,xyz_ldedge,xyz_tredge] = verttail_geometry_function004(airfoil_vtail,r_vtail,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_vtail);


	% SAVING DATA TO GOLBAL MATRICES
	xcvvtail = [xcvvtail, xc(1:end)];
	ycvvtail = [ycvvtail, yc(1:end)];
	zcvvtail = [zcvvtail, zc(1:end)];
	

	xvortic = xvortic(end:-1:1,:);	% CUIDADO!!! For a misterious reason, vortices on the vertical tail are reversed..
	yvortic = yvortic(end:-1:1,:);	% this provides us an opposite direction of the forces!
	zvortic = zvortic(end:-1:1,:);	

	xvmatvtail = [xvmatvtail, xvortic];
	yvmatvtail = [yvmatvtail, yvortic];
	zvmatvtail = [zvmatvtail, zvortic];
	
	xnvvtail = [xnvvtail; -nx];
	ynvvtail = [ynvvtail; -ny];
	znvvtail = [znvvtail; -nz];
		
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapevtail{jj} = xshape;
	yshapevtail{jj} = yshape;
	zshapevtail{jj} = zshape;

	surfvectvtail = [surfvectvtail; surfv];

	xyzldedge_vtail = [xyzldedge_vtail, xyz_ldedge];
	xyztredge_vtail = [xyztredge_vtail, xyz_tredge];

if SYM_vtail == 1		% ############################## SYMMETRY #############################

	r_vtail = [rAvect_vtail(1,jj),-rAvect_vtail(2,jj),rAvect_vtail(3,jj)];
	

	croot   = crootvect_vtail(jj);
	ctip    = ctipvect_vtail(jj);
	b	= bvect_vtail(jj);
	lambda  = lambdavect_vtail(jj);
	delta   = -deltavect_vtail(jj);
	epsilon = epsvect_vtail(jj);
	Nc      = Nc_vtail;
	Nb      = Nbvect_vtail(jj);
	FCR     = FCRvect_vtail(jj);
	xi 	= xivect_vtail(jj);
	if invert_vtail(jj) == 1; xi = -xi; end	

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,dummy,dummy] = verttail_geometry_function004(airfoil_vtail,r_vtail,croot,ctip,b,lambda,delta,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_vtail);


	% SAVING DATA TO GOLBAL MATRICES
	xcvvtail = [xcvvtail, xc(1:end)];
	ycvvtail = [ycvvtail, yc(1:end)];
	zcvvtail = [zcvvtail, zc(1:end)];
	
	xvmatvtail = [xvmatvtail, xvortic];	% The simmetric side is not to be inverted, the normal one is!
	yvmatvtail = [yvmatvtail, yvortic];
	zvmatvtail = [zvmatvtail, zvortic];

	xnvvtail = [xnvvtail; -nx];
	ynvvtail = [ynvvtail; -ny];
	znvvtail = [znvvtail; -nz];

	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapevtail{numel(Nbvect_vtail) + jj} = xshape;
	yshapevtail{numel(Nbvect_vtail) + jj} = yshape;
	zshapevtail{numel(Nbvect_vtail) + jj} = zshape;

	surfvectvtail = [surfvectvtail; surfv];

end % if SYM == 1
end




% CREATING TOTAL GLOBAL BIG COMPLETE AND EVERYTHING MATRICES

xcv = [xcvwing, xcvhtail, xcvvtail];
ycv = [ycvwing, ycvhtail, ycvvtail];
zcv = [zcvwing, zcvhtail, zcvvtail];

xvmat = [xvmatwing, xvmathtail, xvmatvtail];
yvmat = [yvmatwing, yvmathtail, yvmatvtail];
zvmat = [zvmatwing, zvmathtail, zvmatvtail];
	
xnv = [xnvwing; xnvhtail; xnvvtail];
ynv = [ynvwing; ynvhtail; ynvvtail];
znv = [znvwing; znvhtail; znvvtail];
	
%xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

xshape = {}; yshape = {}; zshape = {};

for jj = 1:numel(xshapewing)
	xshape{jj} = xshapewing{jj};
	yshape{jj} = yshapewing{jj};
	zshape{jj} = zshapewing{jj};
end

for jj = 1:numel(xshapehtail)
	xshape{jj+numel(xshapewing)} = xshapehtail{jj};
	yshape{jj+numel(xshapewing)} = yshapehtail{jj};
	zshape{jj+numel(xshapewing)} = zshapehtail{jj};
end

for jj = 1:numel(xshapevtail)
	xshape{jj+numel(xshapewing)+numel(xshapehtail)} = xshapevtail{jj};
	yshape{jj+numel(xshapewing)+numel(xshapehtail)} = yshapevtail{jj};
	zshape{jj+numel(xshapewing)+numel(xshapehtail)} = zshapevtail{jj};
end



surfvect = [surfvectwing; surfvecthtail; surfvectvtail];


% ===============================================
% Important Data
% ===============================================

N_wing = numel(xcvwing);
N_htail = numel(xcvhtail);
N_vtail = numel(xcvvtail);


% ____________________________
% PLOT
% ____________________________

% Shape plot
if plott == 1
	Geometry_Plot = figure;
	hold on
	for jj = 1:numel(xshape)
		plot3(xshape{jj},yshape{jj},zshape{jj},'k','LineWidth',2)
		plot3(CG(1),CG(2),CG(3),'or','LineWidth',3,'MarkerSize',7);
		grid on
		axis equal
	end % for


	%trying to plot the neutral point
	try
		plot3(xN,0,0,'og','LineWidth',3,'MarkerSize',7), legend('shape','Center of Gravity','Neutral Point')
		title(['Static Margin: ',num2str(StaticMargin),' [m]'])
	catch data
	end % try


end % if


% Vortex Ring Plot
if plott == 1
	Geometry_Vortex_Main = figure;
	hold on
	for jj = 1:numel(xshape)
		plot3(xshape{jj},yshape{jj},zshape{jj},'k','LineWidth',2)
		grid on
		axis equal
	end % for

	%plot3(CG(1),CG(2),CG(3),'or','LineWidth',3,'MarkerSize',7);
	plot3(xvmat,yvmat,zvmat,'g')
	quiver3(-2,0,0,cos(alpha0)*cos(beta0), cos(alpha0)*sin(beta0), sin(alpha0),'b','LineWidth',2);
	title('Vortex Rings','FontSize',14)
	axis equal
	axis off
	xlim([-5,10]), ylim([-(2*b+1),2*b+1]), zlim([-10,10])
end % if




