% This script creates the Geometry starting from a loaded Geometry..

global plott alpha0 beta0 Vinf rho

Geometry
Various_Properties


% ===================================================================================
% 			HORIZONTAL TAIL 
% ===================================================================================

% Starting point of every tail section
DELTAxAvect_htail = bvect_htail.*sin(lambdavect_htail)+ctipvect_htail/2.*(1-cos(epsvect_htail));
DELTAyAvect_htail = bvect_htail;
DELTAzAvect_htail = bvect_htail.*sin(deltavect_htail)+ctipvect_htail/2.*sin(epsvect_htail);


xAvect_htail = [0, cumsum(DELTAxAvect_htail(1:end-1))];
yAvect_htail = [0, cumsum(DELTAyAvect_htail(1:end-1))];
zAvect_htail = [0, cumsum(DELTAzAvect_htail(1:end-1))];

rAvect_htail = [xAvect_htail + xA_htail; yAvect_htail + yA_htail; zAvect_htail + zA_htail];

% Initializing main matrices
	xshapehtail = {};	% used only for plotting the shape
	yshapehtail = {};
	zshapehtail = {};

	surfvecthtail = [];	% used to calculate Cp

	xcvhtail = [];		% x controlpoint vector
	ycvhtail = [];
	zcvhtail = [];
	
	xvmathtail = [];		% vortex matrix: columns contain
	yvmathtail = [];		% coordinates of the 4 corners of 
	zvmathtail = [];		% the vortex ring
	
	xnvhtail = [];		% n dot x vector
	ynvhtail = [];		% n dot y
	znvhtail = [];		% n dot z
	
	xmatplothtail = [];
	ymatplothtail = [];
	zmatplothtail = [];

	xyzldedge_htail = [];	% used to calculate mean aerodynamic chord etc..
	xyztredge_htail = [];

for jj = 1:numel(Nbvect_htail)

	r_htail = [rAvect_htail(1,jj),rAvect_htail(2,jj),rAvect_htail(3,jj)];
	

	croot   = crootvect_htail(jj);
	ctip    = ctipvect_htail(jj);
	b	= bvect_htail(jj);
	lambda  = lambdavect_htail(jj);
	delta   = deltavect_htail(jj);
	epsilon0 = eps0vect_htail(jj);
	epsilon = epsvect_htail(jj);
	Nc      = Nc_htail;
	Nb      = Nbvect_htail(jj);
	FCR     = FCRvect_htail(jj);
	xi 	= xivect_htail(jj);

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,xyz_ldedge,xyz_tredge] = wing_geometry_function004(airfoil_htail,r_htail,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_htail);


	% SAVING DATA TO GOLBAL MATRICES
	xcvhtail = [xcvhtail, xc(1:end)];
	ycvhtail = [ycvhtail, yc(1:end)];
	zcvhtail = [zcvhtail, zc(1:end)];
	
	xvmathtail = [xvmathtail, xvortic];
	yvmathtail = [yvmathtail, yvortic];
	zvmathtail = [zvmathtail, zvortic];
	
	xnvhtail = [xnvhtail; nx];
	ynvhtail = [ynvhtail; ny];
	znvhtail = [znvhtail; nz];
	
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapehtail{jj} = xshape;
	yshapehtail{jj} = yshape;
	zshapehtail{jj} = zshape;

	surfvecthtail = [surfvecthtail; surfv];

	xyzldedge_htail = [xyzldedge_htail, xyz_ldedge];
	xyztredge_htail = [xyztredge_htail, xyz_tredge];


if SYM_htail == 1		% ############################## SYMMETRY #############################

	r_htail = [rAvect_htail(1,jj),-rAvect_htail(2,jj),rAvect_htail(3,jj)];
	

	croot   = crootvect_htail(jj);
	ctip    = ctipvect_htail(jj);
	b	= -bvect_htail(jj);
	lambda  = -lambdavect_htail(jj);
	delta   = -deltavect_htail(jj);
	epsilon0= eps0vect_htail(jj);
	epsilon = epsvect_htail(jj);
	Nc      = Nc_htail;
	Nb      = Nbvect_htail(jj);
	FCR     = FCRvect_htail(jj);
	xi 	= xivect_htail(jj);
	if invert_htail(jj) == 1; xi = -xi; end	

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,dummy,dummy] = wing_geometry_function004(airfoil_htail,r_htail,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_htail);


	% SAVING DATA TO GOLBAL MATRICES
	xcvhtail = [xcvhtail, xc(1:end)];
	ycvhtail = [ycvhtail, yc(1:end)];
	zcvhtail = [zcvhtail, zc(1:end)];
	

	xvortic = xvortic(end:-1:1,:);	% CUIDADO!!! Vortex are reversed in simmetric condition!
	yvortic = yvortic(end:-1:1,:);	% if we don't reverse them, we obtain half a wing lifting 
	zvortic = zvortic(end:-1:1,:);	% and the other half ANTI LIFTING!

	xvmathtail = [xvmathtail, xvortic];
	yvmathtail = [yvmathtail, yvortic];
	zvmathtail = [zvmathtail, zvortic];
	
	xnvhtail = [xnvhtail; -nx];
	ynvhtail = [ynvhtail; -ny];
	znvhtail = [znvhtail; -nz];
	
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapehtail{numel(Nbvect_htail) + jj} = xshape;
	yshapehtail{numel(Nbvect_htail) + jj} = yshape;
	zshapehtail{numel(Nbvect_htail) + jj} = zshape;

	surfvecthtail = [surfvecthtail; surfv];

end % if SYM == 1
end





% CREATING TOTAL GLOBAL BIG COMPLETE AND EVERYTHING MATRICES

xcv = [xcvhtail];
ycv = [ycvhtail];
zcv = [zcvhtail];

xvmat = [xvmathtail];
yvmat = [yvmathtail];
zvmat = [zvmathtail];
	
xnv = [xnvhtail];
ynv = [ynvhtail];
znv = [znvhtail];
	
%xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

xshape = {}; yshape = {}; zshape = {};

for jj = 1:numel(xshapehtail)
	xshape{jj} = xshapehtail{jj};
	yshape{jj} = yshapehtail{jj};
	zshape{jj} = zshapehtail{jj};
end

surfvect = [surfvecthtail];


% ===============================================
% Important Data
% ===============================================

N_htail = numel(xcvhtail);

