% This script creates the Geometry starting from a loaded Geometry..

global plott alpha0 beta0 Vinf rho

Geometry
Various_Properties





% ===================================================================================
% 			VERTICAL TAIL 
% ===================================================================================

% Starting point of every tail section
DELTAxAvect_vtail = bvect_vtail.*tan(lambdavect_vtail)+ctipvect_vtail/2.*(1-cos(epsvect_vtail));
DELTAyAvect_vtail = bvect_vtail.*sin(deltavect_vtail)+ctipvect_vtail/2.*sin(epsvect_vtail);
DELTAzAvect_vtail = bvect_vtail;
%DELTAzAvect_vtail = bvect_vtail.*cos(lambdavect_vtail);


xAvect_vtail = [0, cumsum(DELTAxAvect_vtail(1:end-1))];
yAvect_vtail = [0, cumsum(DELTAyAvect_vtail(1:end-1))];
zAvect_vtail = [0, cumsum(DELTAzAvect_vtail(1:end-1))];

rAvect_vtail = [xAvect_vtail + xA_vtail; yAvect_vtail + yA_vtail; zAvect_vtail + zA_vtail];

% Initializing main matrices
	xshapevtail = {};	% used only for plotting the shape
	yshapevtail = {};
	zshapevtail = {};

	surfvectvtail = [];	% used to calculate Cp

	xcvvtail = [];		% x controlpoint vector
	ycvvtail = [];
	zcvvtail = [];
	
	xvmatvtail = [];		% vortex matrix: columns contain
	yvmatvtail = [];		% coordinates of the 4 corners of 
	zvmatvtail = [];		% the vortex ring
	
	xnvvtail = [];		% n dot x vector
	ynvvtail = [];		% n dot y
	znvvtail = [];		% n dot z
	
	xmatplotvtail = [];
	ymatplotvtail = [];
	zmatplotvtail = [];

	xyzldedge_vtail = [];
	xyztredge_vtail = [];


for jj = 1:numel(Nbvect_vtail)

	r_vtail = [rAvect_vtail(1,jj),rAvect_vtail(2,jj),rAvect_vtail(3,jj)];
	

	croot   = crootvect_vtail(jj);
	ctip    = ctipvect_vtail(jj);
	b	= bvect_vtail(jj);
	lambda  = lambdavect_vtail(jj);
	delta   = deltavect_vtail(jj);
	epsilon = epsvect_vtail(jj);
	Nc      = Nc_vtail;
	Nb      = Nbvect_vtail(jj);
	FCR     = FCRvect_vtail(jj);
	xi 	= xivect_vtail(jj);

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,xyz_ldedge,xyz_tredge] = verttail_geometry_function004(airfoil_vtail,r_vtail,croot,ctip,b,lambda,delta,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_vtail);


	% SAVING DATA TO GOLBAL MATRICES
	xcvvtail = [xcvvtail, xc(1:end)];
	ycvvtail = [ycvvtail, yc(1:end)];
	zcvvtail = [zcvvtail, zc(1:end)];
	

	xvortic = xvortic(end:-1:1,:);	% CUIDADO!!! For a misterious reason, vortices on the vertical tail are reversed..
	yvortic = yvortic(end:-1:1,:);	% this provides us an opposite direction of the forces!
	zvortic = zvortic(end:-1:1,:);	

	xvmatvtail = [xvmatvtail, xvortic];
	yvmatvtail = [yvmatvtail, yvortic];
	zvmatvtail = [zvmatvtail, zvortic];
	
	xnvvtail = [xnvvtail; -nx];
	ynvvtail = [ynvvtail; -ny];
	znvvtail = [znvvtail; -nz];
		
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapevtail{jj} = xshape;
	yshapevtail{jj} = yshape;
	zshapevtail{jj} = zshape;

	surfvectvtail = [surfvectvtail; surfv];

	xyzldedge_vtail = [xyzldedge_vtail, xyz_ldedge];
	xyztredge_vtail = [xyztredge_vtail, xyz_tredge];

if SYM_vtail == 1		% ############################## SYMMETRY #############################

	r_vtail = [rAvect_vtail(1,jj),-rAvect_vtail(2,jj),rAvect_vtail(3,jj)];
	

	croot   = crootvect_vtail(jj);
	ctip    = ctipvect_vtail(jj);
	b	= bvect_vtail(jj);
	lambda  = lambdavect_vtail(jj);
	delta   = -deltavect_vtail(jj);
	epsilon = epsvect_vtail(jj);
	Nc      = Nc_vtail;
	Nb      = Nbvect_vtail(jj);
	FCR     = FCRvect_vtail(jj);
	xi 	= xivect_vtail(jj);
	if invert_vtail(jj) == 1; xi = -xi; end	

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,dummy,dummy] = verttail_geometry_function004(airfoil_vtail,r_vtail,croot,ctip,b,lambda,delta,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_vtail);


	% SAVING DATA TO GOLBAL MATRICES
	xcvvtail = [xcvvtail, xc(1:end)];
	ycvvtail = [ycvvtail, yc(1:end)];
	zcvvtail = [zcvvtail, zc(1:end)];
	
	xvmatvtail = [xvmatvtail, xvortic];	% The simmetric side is not to be inverted, the normal one is!
	yvmatvtail = [yvmatvtail, yvortic];
	zvmatvtail = [zvmatvtail, zvortic];

	xnvvtail = [xnvvtail; -nx];
	ynvvtail = [ynvvtail; -ny];
	znvvtail = [znvvtail; -nz];

	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapevtail{numel(Nbvect_vtail) + jj} = xshape;
	yshapevtail{numel(Nbvect_vtail) + jj} = yshape;
	zshapevtail{numel(Nbvect_vtail) + jj} = zshape;

	surfvectvtail = [surfvectvtail; surfv];

end % if SYM == 1
end




% CREATING TOTAL GLOBAL BIG COMPLETE AND EVERYTHING MATRICES

xcv = [xcvvtail];
ycv = [ycvvtail];
zcv = [zcvvtail];

xvmat = [xvmatvtail];
yvmat = [yvmatvtail];
zvmat = [zvmatvtail];
	
xnv = [xnvvtail];
ynv = [ynvvtail];
znv = [znvvtail];
	
%xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

xshape = {}; yshape = {}; zshape = {};

for jj = 1:numel(xshapevtail)
	xshape{jj} = xshapevtail{jj};
	yshape{jj} = yshapevtail{jj};
	zshape{jj} = zshapevtail{jj};
end

surfvect = [surfvectvtail];


% ===============================================
% Important Data
% ===============================================

N_vtail = numel(xcvvtail);

