% This script creates the Geometry starting from a loaded Geometry..

global plott alpha0 beta0 Vinf rho

Geometry
Various_Properties

% ===================================================================================
% 			WING
% ===================================================================================


% Starting point of every wing section
DELTAxAvect_wing = bvect_wing.*tan(lambdavect_wing)+ctipvect_wing/2.*(1-cos(epsvect_wing));
DELTAyAvect_wing = bvect_wing;
DELTAzAvect_wing = bvect_wing.*tan(deltavect_wing)+ctipvect_wing/2.*sin(epsvect_wing);


xAvect_wing = [0, cumsum(DELTAxAvect_wing(1:end-1))];
yAvect_wing = [0, cumsum(DELTAyAvect_wing(1:end-1))];
zAvect_wing = [0, cumsum(DELTAzAvect_wing(1:end-1))];

rAvect_wing = [xAvect_wing + xA_wing; yAvect_wing + yA_wing; zAvect_wing + zA_wing];

% Initializing main matrices
	xshapewing = {};	% used only for plotting the shape
	yshapewing = {};
	zshapewing = {};

	surfvectwing = [];	% used to calculate Cp

	xcvwing = [];		% x controlpoint vector
	ycvwing = [];
	zcvwing = [];
	
	xvmatwing = [];		% vortex matrix: columns contain
	yvmatwing = [];		% coordinates of the 4 corners of 
	zvmatwing = [];		% the vortex ring
	
	xnvwing = [];		% n dot x vector
	ynvwing = [];		% n dot y
	znvwing = [];		% n dot z
	
	xmatplotwing = [];
	ymatplotwing = [];
	zmatplotwing = [];

	xyzldedge_wing = [];	% used to calculate mean aerodynamic chord etc..
	xyztredge_wing = [];


for jj = 1:numel(Nbvect_wing)

	r_wing = [rAvect_wing(1,jj),rAvect_wing(2,jj),rAvect_wing(3,jj)];
	

	croot   = crootvect_wing(jj);
	ctip    = ctipvect_wing(jj);
	b	= bvect_wing(jj);
	lambda  = lambdavect_wing(jj);
	delta   = deltavect_wing(jj);
	epsilon0= eps0vect_wing(jj);
	epsilon = epsvect_wing(jj);
	Nc      = Nc_wing;
	Nb      = Nbvect_wing(jj);
	FCR     = FCRvect_wing(jj);
	xi 	= xivect_wing(jj);

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,xyz_ldedge,xyz_tredge] = wing_geometry_function004(airfoil_wing,r_wing,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_wing);

	% SAVING DATA TO GOLBAL MATRICES
	xcvwing = [xcvwing, xc(1:end)];
	ycvwing = [ycvwing, yc(1:end)];
	zcvwing = [zcvwing, zc(1:end)];
	
	xvmatwing = [xvmatwing, xvortic];
	yvmatwing = [yvmatwing, yvortic];
	zvmatwing = [zvmatwing, zvortic];
	
	xnvwing = [xnvwing; nx];
	ynvwing = [ynvwing; ny];
	znvwing = [znvwing; nz];
	
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapewing{jj} = xshape;
	yshapewing{jj} = yshape;
	zshapewing{jj} = zshape;

	surfvectwing = [surfvectwing; surfv];

	xyzldedge_wing = [xyzldedge_wing, xyz_ldedge];
	xyztredge_wing = [xyztredge_wing, xyz_tredge];
%	xmat_chord_wing = [xmat_chord_wing, xvmat_wing];
%	ymat_chord_wing = [ymat_chord_wing, yvmat_wing];
%	zmat_chord_wing = [zmat_chord_wing, zvmat_wing];


if SYM_wing == 1		% ############################## SYMMETRY #############################

	r_wing = [rAvect_wing(1,jj),-rAvect_wing(2,jj),rAvect_wing(3,jj)];
	

	croot   = crootvect_wing(jj);
	ctip    = ctipvect_wing(jj);
	b	= -bvect_wing(jj);
	lambda  = -lambdavect_wing(jj);
	delta   = -deltavect_wing(jj);
	epsilon0= eps0vect_wing(jj);
	epsilon = epsvect_wing(jj);
	Nc      = Nc_wing;
	Nb      = Nbvect_wing(jj);
	FCR     = FCRvect_wing(jj);
	xi 	= xivect_wing(jj);
	if invert_wing(jj) == 1; xi = -xi; end	

	[nx,ny,nz,surfv,xc,yc,zc,xvortic,yvortic,zvortic,shape_mat,dummy,dummy] = wing_geometry_function004(airfoil_wing,r_wing,croot,ctip,b,lambda,delta,epsilon0,epsilon,Nc,Nb,FCR,xi,alpha0, beta0,SYM_wing);


	% SAVING DATA TO GOLBAL MATRICES
	xcvwing = [xcvwing, xc(1:end)];
	ycvwing = [ycvwing, yc(1:end)];
	zcvwing = [zcvwing, zc(1:end)];
	

	xvortic = xvortic(end:-1:1,:);	% CUIDADO!!! Vortex are reversed in simmetric condition!
	yvortic = yvortic(end:-1:1,:);	% if we don't reverse them, we obtain half a wing lifting 
	zvortic = zvortic(end:-1:1,:);	% and the other half ANTI LIFTING!
	
	xvmatwing = [xvmatwing, xvortic];
	yvmatwing = [yvmatwing, yvortic];
	zvmatwing = [zvmatwing, zvortic];
	
	xnvwing = [xnvwing; -nx];
	ynvwing = [ynvwing; -ny];
	znvwing = [znvwing; -nz];
	
	xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

	xshapewing{numel(Nbvect_wing) + jj} = xshape;
	yshapewing{numel(Nbvect_wing) + jj} = yshape;
	zshapewing{numel(Nbvect_wing) + jj} = zshape;

	surfvectwing = [surfvectwing; surfv];
end % ...if SYM == 1...
end




% CREATING TOTAL GLOBAL BIG COMPLETE AND EVERYTHING MATRICES

xcv = [xcvwing];
ycv = [ycvwing];
zcv = [zcvwing];

xvmat = [xvmatwing];
yvmat = [yvmatwing];
zvmat = [zvmatwing];
	
xnv = [xnvwing];
ynv = [ynvwing];
znv = [znvwing];
	
%xshape = shape_mat(1,:); yshape = shape_mat(2,:); zshape = shape_mat(3,:);

xshape = {}; yshape = {}; zshape = {};

for jj = 1:numel(xshapewing)
	xshape{jj} = xshapewing{jj};
	yshape{jj} = yshapewing{jj};
	zshape{jj} = zshapewing{jj};
end



surfvect = [surfvectwing];


% ===============================================
% Important Data
% ===============================================

N_wing = numel(xcvwing);

