% MODULE Aerodynamic Points


global plott alpha0 beta0 Vinf rho




% Calculating Aerodynamic Coefficients Matrix, if not done yet!
try
	MAT;	% let's see if MAT already exists
catch outputtt;
	[MAT] = Vortex_Lattice_INDUCEDVELOCITYFUNCTION('');
end



% #############################################################################################
% #############################################################################################
% 				NEUTRAL POINT 
% #############################################################################################
% #############################################################################################

if neutral_point_computation == 1
	
	alpha1 = alpha0 - 2*pi/180;
	alpha2 = alpha0 + 2*pi/180;
	
	if beta0 ~= 0
		fprintf('PERICOLO MORTALEEEE (forse)!!!!! You''re calculating the position of Neutral Point\n');
		fprintf('in a linearization condition with BETA NOT 0!!\n');
	end
	
	refPoint1 = [1,0,0];
	refPoint2 = [2,0,0];
	
	[d,d,d,M1] = Vortex_Lattice_SYSTEMSOLVERFUNCTION(MAT,alpha1,0,0,0,0,0,0,0,refPoint1);
	[d,d,d,M2] = Vortex_Lattice_SYSTEMSOLVERFUNCTION(MAT,alpha2,0,0,0,0,0,0,0,refPoint1);
	Mx_alpha1 = (M2(1)-M1(1))/(alpha2 - alpha1);
	My_alpha1 = (M2(2)-M1(2))/(alpha2 - alpha1);
	Mz_alpha1 = (M2(3)-M1(3))/(alpha2 - alpha1);
	
	[d,d,d,M1] = Vortex_Lattice_SYSTEMSOLVERFUNCTION(MAT,alpha1,0,0,0,0,0,0,0,refPoint2);
	[d,d,d,M2] = Vortex_Lattice_SYSTEMSOLVERFUNCTION(MAT,alpha2,0,0,0,0,0,0,0,refPoint2);
	Mx_alpha2 = (M2(1)-M1(1))/(alpha2 - alpha1);
	My_alpha2 = (M2(2)-M1(2))/(alpha2 - alpha1);
	Mz_alpha2 = (M2(3)-M1(3))/(alpha2 - alpha1);
	
	x1 = refPoint1(1); x2 = refPoint2(1);
	M1 = My_alpha1;  M2 = My_alpha2;
	
	coefs = polyfit([x1,x2],[M1,M2],1);
	straight_line = @(x) coefs(1)*x + coefs(2);
	
	% HERE IT IS
	xN = -coefs(2)/coefs(1);			% Deltay = tan(theta) * Deltax...
	StaticMargin = xN - CG(1);
	fprintf('X Neutral Point = %f\n',xN);
	fprintf('Static Margin   = %f\n',StaticMargin);

	% PLOTTT
	Geometry_Static_Margin = figure;
	hold on
	plot3(CG(1),CG(2),CG(3),'or','LineWidth',3,'MarkerSize',7);
	plot3(xN,0,0,'og','LineWidth',3,'MarkerSize',7)
	legend('Center of Gravity','Neutral Point')
	for jj = 1:numel(xshape)
		plot3(xshape{jj},yshape{jj},zshape{jj},'k','LineWidth',2)
		grid on
		axis equal
	end % for
	title(['Static Margin: ',num2str(StaticMargin),' [m]'])


end % if neutral_point..


% #############################################################################################
% #############################################################################################
% 		AERODYNAMIC CENTERS and LIFTING DERIVATIVES COMPUTATION
% #############################################################################################
% #############################################################################################
% In this point I'll import only one geometry a time, and calculate the aerodynamic centers..

% 1) attivo una geometria alla volta e calcolo MAT
% 2) RICALCOLO la geometria originale e MAT, SENNO'' NEGLI ALTRI PUNTI FACCIO CASINI!!!!!!!

if aerodynamic_centers_lifting_derivatives == 1
	
	alpha1 = alpha0 - 2*pi/180;
	alpha2 = alpha0 + 2*pi/180;
	
	if beta0 ~= 0
		fprintf('PERICOLO MORTALEEEE (forse)!!!!! You''re calculating the position of Neutral Point\n');
		fprintf('in a linearization condition with BETA NOT 0!!\n');
	end
	
	refPoint1 = [1,0,0];
	refPoint2 = [2,0,0];

	%  ______________________________    WING    ________________________________________
	Geometry_Creator_WingOnly

	[MAT_Wing] = Vortex_Lattice_INDUCEDVELOCITYFUNCTION_WingOnly('working to find Wing Aerodynamic center...');
	
	[d,d,d,M1] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_WingOnly(MAT_Wing,alpha1,0,0,0,0,0,0,0,refPoint1);
	[d,d,d,M2] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_WingOnly(MAT_Wing,alpha2,0,0,0,0,0,0,0,refPoint1);
	Mx_alpha1 = (M2(1)-M1(1))/(alpha2 - alpha1);
	My_alpha1 = (M2(2)-M1(2))/(alpha2 - alpha1);
	Mz_alpha1 = (M2(3)-M1(3))/(alpha2 - alpha1);
	
	[d,d,d,M1] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_WingOnly(MAT_Wing,alpha1,0,0,0,0,0,0,0,refPoint2);
	[d,d,d,M2] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_WingOnly(MAT_Wing,alpha2,0,0,0,0,0,0,0,refPoint2);
	Mx_alpha2 = (M2(1)-M1(1))/(alpha2 - alpha1);
	My_alpha2 = (M2(2)-M1(2))/(alpha2 - alpha1);
	Mz_alpha2 = (M2(3)-M1(3))/(alpha2 - alpha1);
	
	x1 = refPoint1(1); x2 = refPoint2(1);
	M1 = My_alpha1;  M2 = My_alpha2;
	
	coefs = polyfit([x1,x2],[M1,M2],1);
	straight_line = @(x) coefs(1)*x + coefs(2);
	
	% HERE IT IS
	xN_wing = -coefs(2)/coefs(1);			% Deltay = tan(theta) * Deltax...


	%  ______________________________    HORIZONTAL TAIL    _____________________________

	[MAT_Htail] = Vortex_Lattice_INDUCEDVELOCITYFUNCTION_HtailOnly('working to find Horizontal Tail Aerodynamic center...');
	
	[d,d,d,M1,L1] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_HtailOnly(MAT_Htail,alpha1,0,0,0,0,0,0,0,refPoint1);
	[d,d,d,M2,L2] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_HtailOnly(MAT_Htail,alpha2,0,0,0,0,0,0,0,refPoint1);
	Mx_alpha1 = (M2(1)-M1(1))/(alpha2 - alpha1);
	My_alpha1 = (M2(2)-M1(2))/(alpha2 - alpha1);
	Mz_alpha1 = (M2(3)-M1(3))/(alpha2 - alpha1);
	
	L_alpha_htail = (L2 - L1)/(alpha2-alpha1);
	M_alpha_htail = (M2(2) - M1(2))/(alpha2-alpha1);

	[d,d,d,M1] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_HtailOnly(MAT_Htail,alpha1,0,0,0,0,0,0,0,refPoint2);
	[d,d,d,M2] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_HtailOnly(MAT_Htail,alpha2,0,0,0,0,0,0,0,refPoint2);
	Mx_alpha2 = (M2(1)-M1(1))/(alpha2 - alpha1);
	My_alpha2 = (M2(2)-M1(2))/(alpha2 - alpha1);
	Mz_alpha2 = (M2(3)-M1(3))/(alpha2 - alpha1);
	
	x1 = refPoint1(1); x2 = refPoint2(1);
	M1 = My_alpha1;  M2 = My_alpha2;
	
	coefs = polyfit([x1,x2],[M1,M2],1);
	straight_line = @(x) coefs(1)*x + coefs(2);
	
	% HERE IT IS
	xN_htail = -coefs(2)/coefs(1);			% Deltay = tan(theta) * Deltax...


	% ---- now lifting and moment derivatives ----
	[d,d,d,M1,L1] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_HtailOnly(MAT_Htail,alpha1,0,0,0,0,0,0,0,CG);
	[d,d,d,M2,L2] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_HtailOnly(MAT_Htail,alpha2,0,0,0,0,0,0,0,CG);

	L_alpha_htail = (L2 - L1)/(alpha2-alpha1);
	M_alpha_htail = (M2(2) - M1(2))/(alpha2-alpha1);

	a_htail = L_alpha_htail/(0.5*rho*Vinf^2*sum(surfvecthtail));



	% ---- now lifting and moment derivatives ----
	[d,d,d,M1,L1,d,d,d,d,Epsilon1] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_WingOnly(MAT_Wing,alpha1,0,0,0,0,0,0,0,CG,[xN_htail,0,0]);
	[d,d,d,M2,L2,d,d,d,d,Epsilon2] = Vortex_Lattice_SYSTEMSOLVERFUNCTION_WingOnly(MAT_Wing,alpha2,0,0,0,0,0,0,0,CG,[xN_htail,0,0]);

	L_alpha_wing = (L2 - L1)/(alpha2-alpha1);
	M_alpha_wing = (M2(2) - M1(2))/(alpha2-alpha1);

	dEPSdALPHA = (Epsilon2-Epsilon1)/(alpha2-alpha1);

	% Clear..... 
	clear MAT_Wing MAT_Htail



	% ____________________________ Writing to a File ____________________________________	
	fid = fopen('Aerodynamic_Centers.dat','w');
	fprintf(fid,'%% This File contains the x position of Aerodynamic centers\n');
	fprintf(fid,'%% ---------------------------------------------------------- \n');
	fprintf(fid,'%% xN wing: \n');
	fprintf(fid,'%f\n',xN_wing);
	fprintf(fid,'%% xN horizontal tail: \n');
	fprintf(fid,'%f\n',xN_htail);
	try
		xN;
		fprintf(fid,'%% xN complete aircraft (Neutral Point):\n');
		fprintf(fid,'%f\n',xN);
	catch outputtt
	end

	fclose(fid);


	% __________________ BACK TO THE COMPLETE SITUATION _________________________________

	Geometry_Creator

	% ________________________________ PLOT _____________________________________________
	


	Geometry_Aerodynamic_Centers = figure;
	hold on
	plot3(CG(1),CG(2),CG(3),'or','LineWidth',3,'MarkerSize',7);
	plot3(xN_wing,0,zA_wing,'oc','LineWidth',3,'MarkerSize',7);
	plot3(xN_htail,0,zA_htail,'oc','LineWidth',3,'MarkerSize',7);
	legend('Center of Gravity','Wing Aerodynamic Center','Horizontal Tail Aerodynamic Center');
	title(['xA wing = ',num2str(xN_wing),'; xA horztail = ',num2str(xN_htail)],'FontSize',14)
	try
		plot3(xN,0,0,'og','LineWidth',3,'MarkerSize',7)
		legend('Center of Gravity','Wing Aerodynamic Center','Horizontal Tail Aerodynamic Center','Neutral Point')
	catch outputtt
	end

	for jj = 1:numel(xshape)
		plot3(xshape{jj},yshape{jj},zshape{jj},'k','LineWidth',2)
		grid on
		axis equal
	end % for

end
