% MODULE_Geometry_Various
%
% This module is governed by the "What_To_Do.m" file.. like all the other modules!
%

% _________________________________________________________________________________________
% _________________________________________________________________________________________

if plot_normal_vectors == 1
	
	% Vortex Ring Plot
	Geometry_Vortex_Main = figure;
	hold on
	for jj = 1:numel(xshape)
		plot3(xshape{jj},yshape{jj},zshape{jj},'k','LineWidth',2)
		grid on
		axis equal
	end

	%plot3(CG(1),CG(2),CG(3),'or','LineWidth',3,'MarkerSize',7);
	quiver3(xcv,ycv,zcv,xnv,ynv,znv,'r');
	title('Normal Vectors','FontSize',14)
	axis equal
	axis off
	%xlim([-2,6]), ylim([-(b+1),b+1]), zlim([-6,6])
end

% _________________________________________________________________________________________
% _________________________________________________________________________________________

if surfaces_and_aerodynamic_chords == 1
	
	% This section writes on the file "Surfaces_and_Chords.dat" surfaces
	% and M.A.C. of wing, horizontal tail and vertical tail

	% MEAN AERODYNAMIC CHORD
	% --- wing ---
	xldedge_wing	= xyzldedge_wing(1,:);		yldedge_wing 	= xyzldedge_wing(2,:);
	xtredge_wing	= xyztredge_wing(1,:);		ytredge_wing 	= xyztredge_wing(2,:);

	chordvect_wing 	= abs( xtredge_wing(1:end-1) - xldedge_wing(1:end-1) );
	deltay_wing	= abs( yldedge_wing(2:end) - yldedge_wing(1:end-1) );

	surfvectwing_temp = (crootvect_wing + ctipvect_wing).*bvect_wing/2;
	MAC_wing	= 1/sum(surfvectwing_temp)*sum( chordvect_wing.^2 .* deltay_wing );
%	MAC_wing	= 1/sum(surfvectwing)*sum( chordvect_wing.^2 .* deltay_wing );

	% --- horizontal tail ---
	xldedge_htail	= xyzldedge_htail(1,:);		yldedge_htail 	= xyzldedge_htail(2,:);
	xtredge_htail	= xyztredge_htail(1,:);		ytredge_htail 	= xyztredge_htail(2,:);

	chordvect_htail	= abs( xtredge_htail(1:end-1) - xldedge_htail(1:end-1) );
	deltay_htail	= abs( yldedge_htail(2:end) - yldedge_htail(1:end-1) );
	surfvecthtail_temp = (crootvect_htail + ctipvect_htail).*bvect_htail/2;
	MAC_htail	= 1/(sum(surfvecthtail_temp))*sum( chordvect_htail.^2 .* deltay_htail );
%	MAC_htail	= 1/(sum(surfvecthtail))*sum( chordvect_htail.^2 .* deltay_htail );

	% --- vertical tail ---
	xldedge_vtail	= xyzldedge_vtail(1,:);		zldedge_vtail 	= xyzldedge_vtail(3,:);
	xtredge_vtail	= xyztredge_vtail(1,:);		ztredge_vtail 	= xyztredge_vtail(3,:);

	chordvect_vtail	= abs( xtredge_vtail(1:end-1) - xldedge_vtail(1:end-1) );
	deltaz_vtail	= abs( zldedge_vtail(2:end) - zldedge_vtail(1:end-1) );
	surfvectvtail_temp = (crootvect_vtail + ctipvect_vtail).*bvect_vtail/2;
	MAC_vtail	= 1/(sum(surfvectvtail_temp))*sum( chordvect_vtail.^2 .* deltaz_vtail );
%	MAC_vtail	= 1/(sum(surfvectvtail))*sum( chordvect_vtail.^2 .* deltaz_vtail );


	fid = fopen('Surfaces_and_Chords.dat','w');
	fprintf(fid,'%% __________________________________________________\n');
	fprintf(fid,'%% __________________________________________________\n');
	fprintf(fid,'%% This file contains surfaces and chords of the lifting surfaces.\n');
	fprintf(fid,'%% Since at the moment I''m programming in Milan, surfaces and chords\n');
	fprintf(fid,'%% are expressed in IS units. Pretty sure many will be grateful for\n');
	fprintf(fid,'%% this choice! :P \n');
	fprintf(fid,'%% ATTENTION PLEEEEEASE !!!!!!!!!!!\n');
	fprintf(fid,'%% The printed surface of every single section is the geometric surface, \n');
	fprintf(fid,'%% calculated with the "trapetium" area formula (b+B)*h/2.. the "NUMERICAL\n');
	fprintf(fid,'%% Total surface" is the sum of the panels surfaces. If you have few vortices,\n');
	fprintf(fid,'%% the Total Surface can differ a lot from the geometrical plotted surface!\n');
	fprintf(fid,'%% The reason is that vortex rings are collocated not at the leading edge, \n');
	fprintf(fid,'%% but instead at the line of quarter chord of every wing panel!\n');
	fprintf(fid,'%% The same is not true on the trailing edge, where the surface of the panels\n');
	fprintf(fid,'%% is from the edge of the vortex ring to the trailing edge (for sake of simplicity\n');
	fprintf(fid,'%% So... be prepared for a Total surface a little smaller than it should be..\n');
	fprintf(fid,'%% Also.. it could be a little bigger, because of numerical error if the panels\n');
	fprintf(fid,'%% are very deformated..\n');
	fprintf(fid,'%% AND REMEMBER THAT Cp IS CALCULATED BY DIVIDING FORCES WITH THAT NUMERICAL SURFACE!!\n');
	fprintf(fid,'%% __________________________________________________\n');
	fprintf(fid,'%% __________________________________________________\n');


	% WING
	fprintf(fid,'%%\n%% ----- WING -----\n');
	fprintf(fid,'%% Surface of every wing segment\n');
	for ii = 1:numel(bvect_wing)
		fprintf(fid,'%f ',surfvectwing_temp(ii)) ; % ... "trapetium" area...
	end
	fprintf(fid,'\n');
	fprintf(fid,'%% Total NUMERICAL Wing surface\n');
	fprintf(fid,'%f\n',sum(surfvectwing));
	fprintf(fid,'%% Mean Aerodynamic Chord [m]\n');
	fprintf(fid,'%f\n',MAC_wing);


	% HORIZONTAL TAIL
	fprintf(fid,'%%\n%% ----- HORIZONTAL TAIL -----\n');
	fprintf(fid,'%% Surface of every htail segment\n');
	for ii = 1:numel(bvect_htail)
		fprintf(fid,'%f ',surfvecthtail_temp(ii)) ; % ... "trapetium" area...
	end
	fprintf(fid,'\n');

	fprintf(fid,'%% Total NUMERICAL Horizontal Tail surface\n');
	fprintf(fid,'%f\n',sum(surfvecthtail));
	fprintf(fid,'%% Mean Aerodynamic Chord [m]\n');
	fprintf(fid,'%f\n',MAC_htail);




	% VERTICAL TAIL
	fprintf(fid,'%%\n%% ----- VERTICAL TAIL -----\n');
	fprintf(fid,'%% Surface of every vtail segment\n');
	for ii = 1:numel(bvect_vtail)
		fprintf(fid,'%f ',surfvectvtail_temp(ii)) ; % ... "trapetium" area...
	end
	fprintf(fid,'\n');

	fprintf(fid,'%% Total NUMERICAL Vertical Tail surface\n');
	fprintf(fid,'%f\n',sum(surfvectvtail));
	fprintf(fid,'%% Mean Aerodynamic Chord [m]\n');
	fprintf(fid,'%f\n',MAC_vtail);


	
	clear surfvectwing_temp surfvecthtail_temp surfvectvtail_temp


end
