% MODULE MESH EXPORTING

%	control_points 				= 1;
%	normal_vectors 				= 1;
%	surface_area				= 1;
%	vortex_corners				= 1;


xvmatTOT = [xvmatwing, xvmathtail, xvmatvtail];
yvmatTOT = [yvmatwing, yvmathtail, yvmatvtail];
zvmatTOT = [zvmatwing, zvmathtail, zvmatvtail];

fid = fopen('Generated_Mesh.dat','w');
fprintf(fid,'%% This file contains the mesh geometry, arranged in the following manner:\n');
fprintf(fid,'%% xcv || ycv || zcv || nx || ny || nz || Surface || x VortexCorner1 || x VC2 || x VC3 || x VC4\n %% || y VortexCorner1 || y VC2 || y VC3 || y VC4 || z VC1 || z VC2 || z VC3 || z VC4\n');
for ii = 1:numel(xcv)
	% control points
	fprintf(fid,'%f %f %f ',xcv(ii),ycv(ii),zcv(ii));
	% normal vectors
	fprintf(fid,'%f %f %f ',xnv(ii),ynv(ii),znv(ii));
	% surface area
	fprintf(fid,'%f ',surfvect(ii));
	% Vortex corners
	fprintf(fid,'%f %f %f %f ',xvmatTOT(1,ii),xvmatTOT(2,ii),xvmatTOT(3,ii),xvmatTOT(4,ii));
	fprintf(fid,'%f %f %f %f ',yvmatTOT(1,ii),yvmatTOT(2,ii),yvmatTOT(3,ii),yvmatTOT(4,ii));
	fprintf(fid,'%f %f %f %f ',zvmatTOT(1,ii),zvmatTOT(2,ii),zvmatTOT(3,ii),zvmatTOT(4,ii));

end
