%Var_Geometry file

global plott alpha0 beta0 Vinf rho

CG = [1;0;0];

%refPoint = [0;0;0];		% reference point for "MOMENT???" calculation
% NONONO, IT'S DEFINED BY USER WHEN CALLING THE FUNCTION Vortex_Lattice_Function!


% _____________________________________
% Importing Geometry
% _____________________________________

% initializing main matrices

xshape = [];	% used only for plotting the shape
yshape = [];
zshape = [];

surfvect = [];	% used to calculate Cp

xcv = [];	% x controlpoint vector
ycv = [];
zcv = [];

xvmat = [];	% vortex matrix: columns contain
yvmat = [];	% coordinates of the 4 corners of 
zvmat = [];	% the vortex ring

xnv = [];	% n dot x vector
ynv = [];	% n dot y
znv = [];	% n dot z

xmatplot = [];
ymatplot = [];
zmatplot = [];

% Geometry Import

% initializing values.. if the relative element is imported, the value is overwritten.
% so, don't mind about this..
Nrightwing = 0; 	Ncrightwing = 0; 	Nbrightwing = 0;
Nleftwing = 0;		Ncleftwing = 0;		Nbleftwing = 0;
Nverttail = 0;		Ncverttail = 0;		Nbverttail = 0;
Nrighttail = 0;		Ncrighttail = 0; 	Nbrighttail = 0;
Nlefttail = 0;		Nclefttail = 0; 	Nblefttail = 0;	

if plott == 1, plot3(0,0,0,'y'), hold on, title('Panelization','FontSize',14), end
wing_geometry002
verttail_geometry002
horztail_geometry002
if plott == 1, plot3(xcv,ycv,zcv,'+r'), end


nx = xnv; ny = ynv; nz = znv;

% mod vector
mod = sqrt( (xvmat(2,:)-xvmat(1,:)).^2 + (yvmat(2,:)-yvmat(1,:)).^2 +(zvmat(2,:)-zvmat(1,:)).^2 )';

% ____________________________
% PLOT
% ____________________________

if plott == 1
	Geometria_Main = figure;
	plot3(xshape,yshape,zshape,'k','LineWidth',2), grid on
	hold on
	plot3(CG(1),CG(2),CG(3),'ok','LineWidth',3,'MarkerSize',7);

	try
		plot3(xN,0,0,'og','LineWidth',3,'MarkerSize',7), legend('shape','Center of Gravity','Neutral Point')
		StaticMargin = xN - CG(1);
		title(['Static Margin: ',num2str(StaticMargin),' [m]'])
	catch data
	end

	xlim([-2,6]), ylim([-(b+1),b+1]), zlim([-6,6])
	
	axis equal
	axis off
end

% Vortex Ring Plot
if plott == 1
	Geometria_Vortex_Main = figure;
	plot3(xshape,yshape,zshape,'k','LineWidth',2), grid on
	hold on
	plot3(xvmat,yvmat,zvmat,'g')
	quiver3(-1,0,0,cos(alpha0)*cos(beta0), cos(alpha0)*sin(beta0), sin(alpha0),'k','LineWidth',2);
	title('Vortex Rings','FontSize',14)
	axis equal
	axis off
	xlim([-2,6]), ylim([-(b+1),b+1]), zlim([-6,6])
end
