% Vortex Lattice Dynamics

close all
clear
clc

global plott alpha0 beta0 Vinf rho



% Importing Initial Conditions File
Initial_Conditions

% Importing Properties
Various_Properties

% Importing Geometry Data
Geometry

% Creating Geometry
plott = 1; Geometry_Creator; plott = 0;



% __________________________________________________
% NOW CHOOSING WHAT TO DO...
% __________________________________________________

% WHAT-TO-DO file

What_To_Do

if	Geometry_Various	== 1
		MODULE_Geometry_Various;
end

if 	Aerodynamic_Forces	== 1
		MODULE_Aerodynamic_Forces;
end

if	Component_Aerodynamics	== 1
		MODULE_Component_Aerodynamics;
end

if	Stability_Derivatives 	== 1
		MODULE_Stability_Derivatives;
end

if	Longitudinal_Modes 	== 1
		MODULE_Longitudinal_Modes;
end

if	Lateral_Modes		== 1
		MODULE_Lateral_Modes;
end

if	Mesh_Exporting		== 1
		MODULE_Mesh_Exporting;
end


