function [A] = Vortex_Lattice_INDUCEDVELOCITYFUNCTION_WingOnly(message);

% The function imports the geometry and computes the forces acting for a given configuration
% alpha, beta

global plott alpha0 beta0 Vinf rho


% _____________________________________
% IMPORTING GEOMETRY
% _____________________________________

Geometry_Creator_WingOnly			% Importing Geometry
mod = sqrt( (xvmat(2,:)-xvmat(1,:)).^2 + (yvmat(2,:)-yvmat(1,:)).^2 +(zvmat(2,:)-zvmat(1,:)).^2 )';



% _____________________________________
% CREATING THE LINEAR SYSTEM
% _____________________________________


Ui = zeros(numel(xcv),size(xvmat,2));
Vi = zeros(numel(xcv),size(xvmat,2));
Wi = zeros(numel(xcv),size(xvmat,2));

if nargin < 1
	message = 'Creating matrix of aerodynamic infuluence coefficients';
end
ww = waitbar(0,message);
for ii = 1:numel(xcv)	% for every control point

	ww = waitbar(ii/numel(xcv),ww);

	for jj = 1:size(xvmat,2)

		r0_1 = [xvmat(2,jj)-xvmat(1,jj); yvmat(2,jj)-yvmat(1,jj);zvmat(2,jj)-zvmat(1,jj)];
		r1_1 = [xcv(ii)-xvmat(1,jj); ycv(ii)-yvmat(1,jj); zcv(ii)-zvmat(1,jj)];
		r2_1 = [xcv(ii)-xvmat(2,jj); ycv(ii)-yvmat(2,jj); zcv(ii)-zvmat(2,jj)];
		
		r0_2 = [xvmat(3,jj)-xvmat(2,jj); yvmat(3,jj)-yvmat(2,jj);zvmat(3,jj)-zvmat(2,jj)];
		r1_2 = [xcv(ii)-xvmat(2,jj); ycv(ii)-yvmat(2,jj); zcv(ii)-zvmat(2,jj)];
		r2_2 = [xcv(ii)-xvmat(3,jj); ycv(ii)-yvmat(3,jj); zcv(ii)-zvmat(3,jj)];

		r0_3 = [xvmat(4,jj)-xvmat(3,jj); yvmat(4,jj)-yvmat(3,jj);zvmat(4,jj)-zvmat(3,jj)];
		r1_3 = [xcv(ii)-xvmat(3,jj); ycv(ii)-yvmat(3,jj); zcv(ii)-zvmat(3,jj)];
		r2_3 = [xcv(ii)-xvmat(4,jj); ycv(ii)-yvmat(4,jj); zcv(ii)-zvmat(4,jj)];

		r0_4 = [xvmat(1,jj)-xvmat(4,jj); yvmat(1,jj)-yvmat(4,jj);zvmat(1,jj)-zvmat(4,jj)];
		r1_4 = [xcv(ii)-xvmat(4,jj); ycv(ii)-yvmat(4,jj); zcv(ii)-zvmat(4,jj)];
		r2_4 = [xcv(ii)-xvmat(1,jj); ycv(ii)-yvmat(1,jj); zcv(ii)-zvmat(1,jj)];

		r1xr2_1 = cross(r1_1,r2_1);
		r1xr2_2 = cross(r1_2,r2_2);
		r1xr2_3 = cross(r1_3,r2_3);
		r1xr2_4 = cross(r1_4,r2_4);

		VIND_1 = 1/(4*pi) * r1xr2_1 / norm(r1xr2_1)^2 * r0_1' * (r1_1/norm(r1_1) - r2_1/norm(r2_1));
		VIND_2 = 1/(4*pi) * r1xr2_2 / norm(r1xr2_2)^2 * r0_2' * (r1_2/norm(r1_2) - r2_2/norm(r2_2));
		VIND_3 = 1/(4*pi) * r1xr2_3 / norm(r1xr2_3)^2 * r0_3' * (r1_3/norm(r1_3) - r2_3/norm(r2_3));
		VIND_4 = 1/(4*pi) * r1xr2_4 / norm(r1xr2_4)^2 * r0_4' * (r1_4/norm(r1_4) - r2_4/norm(r2_4));

		VIND = VIND_1 + VIND_2 + VIND_3 + VIND_4;

		Ui(ii,jj) = VIND(1);
		Vi(ii,jj) = VIND(2);
		Wi(ii,jj) = VIND(3);
	
end
end
close(ww)



% TIME TO GENERATE THE LINEAR SISTEM!

A = Ui.*repmat(xnv,1,numel(xcv)) + Vi.*repmat(ynv,1,numel(xcv)) + Wi.*repmat(znv,1,numel(xcv));


return
